/*

// BEGIN__HARVEST_EXCEPTION_ZSTRING

<javascriptresource>
<name>$$$/JavaScripts/PSDBreaker/Menu=PSDBreaker</name>
<about>$$$/JavaScripts/PSDBreaker/About=PSDBreaker^r^rCopyright 2010 Krogos Software. All rights reserved.^r^rExports to HTML.</about>
</javascriptresource>

// END__HARVEST_EXCEPTION_ZSTRING

*/



//BREAK
var pngIndex = 0;

// the drop down list indexes for tiff compression
var compNoneIndex = 0;
var compLZWIndex = 1;
var compZIPIndex = 2;
var compJPEGIndex = 3;

// ok and cancel button
var runButtonID = 1;
var cancelButtonID = 2;

var layerslist;

$.basepath = "";
$.docname = "";    

$.emptyLayerSet = "EmptyLayerSet";

$.openFile = function(filename)
{
	new File(filename).execute();
}

//BREAK

$.convertActiveDocument = function(path,useExistingExport)
{
	app.playbackDisplayDialogs = DialogModes.ERROR;
	
	var newOpen = false;
	if( path != "")
	{	
		try {
			app.activeDocument = app.open(new File(path));
			newOpen = true;
		} catch(e)
		{
			alert( e);
		}
	} else {
		try {
			app.activeDocument.fullName;
		} catch(e)
		{
			alert( "Please open a document or save the current one!");
			return "";
		}
	}

    var exportInfo = new Object();
    
    $.initExportInfo(exportInfo);
 
	$.docName = app.activeDocument.name;  // save the app.activeDocument name before duplicate.
	$.docName = $.docName.replace( ".psd", "");

    $.settingDialog(exportInfo);

	var layerCount = app.activeDocument.layers.length;
	var layerSetsCount = app.activeDocument.layerSets.length;
        
	var rememberMaximize;
	var needMaximize = exportInfo.psdMaxComp ? QueryStateType.ALWAYS : QueryStateType.NEVER;

	app.activeDocument = app.activeDocument;
	var doc = app.activeDocument;
	
	$.basepath = Folder(app.activeDocument.fullName.parent).fsName;
	var fld = new Folder( $.basepath+"/" + $.docName);
	if( !fld.exists)
		fld.create();
	exportInfo.destination = $.basepath+"/" + $.docName;
	exportInfo.fileNamePrefix = $.docName+"_";
	
	if( useExistingExport)
		return $.basepath+"/" + $.docName+"/result.xml";

	if( app.activeDocument.mode != DocumentMode.RGB)
		app.activeDocument.changeMode( ChangeMode.RGB);

	layerslist = new Array();
	var start = new Date().getTime();
	
	var descXml = $.exportXml(layerslist, exportInfo);
	if( descXml == "")
		return "";
	$.writeFile(descXml, new File( $.basepath+"/" + $.docName+"/result.xml"));

	$.SetInvisibleAllArtLayers(layerslist);
	$.exportSingleImages( layerslist, exportInfo);
	$.exportCompositeImages( layerslist, exportInfo);

	end = new Date().getTime();
//	alert( (end-start)/1000 + "seconds");
	
	if( newOpen)
		app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);		

	app.playbackDisplayDialogs = DialogModes.ALL;
	
	return $.basepath+"/" + $.docName+"/result.xml";
}		

$.GetName = function( l, layerBounds)
{
	var r = layerBounds[l];
	return l + " " + r.x1 + " " + r.y1 + " " + r.x2 + " " + r.y2;
}

//BREAK

$.exportXml = function (layerslist, exportInfo) 
{
	var descXml = "";
	
	var docoriginal = app.activeDocument;
	var docIndex = $.getDocumentIndex( docoriginal);

	var layerStack = new Array();
	var xmlDescriptions = new Array();
	var xmlDescriptionsVisible = new Array();
	var layersVisible = new Array();
	var allLayers = new Object();
	var allLayerBounds = new Array();
	var layerBounds = new Array();
	
	try {
		var l = docoriginal.backgroundLayer;
		var visible = l.visible;
		app.activeDocument.activeLayer = l;
		layerStack.push( l);
		var desc = $.getActiveLayerInfoByDocIndex(docIndex);
		xmlDescriptions.push( $.dumpDesc( desc, 0));

		var r = l.bounds;
		var x1 = r[0]; x1.convert( "px");
		var y1 = r[1]; y1.convert( "px");
		var x2 = r[2]; x2.convert( "px");
		var y2 = r[3]; y2.convert( "px");
		var b = new Object();
		b.x1 = x1.value;
		b.y1 = y1.value;
		b.x2 = x2.value;
		b.y2 = y2.value;
		allLayerBounds.push( b);

		layersVisible[0] = visible;
	} catch( e)
	{
	}

	var dw = docoriginal.width;
	dw.convert("px");
	var dh = docoriginal.height;
	dh.convert("px");

	try {
		for( var i = 1; true; i++)
		{	
			var ref = new ActionReference();
			ref.putIndex(app.charIDToTypeID("Lyr "), i);
			var desc = new ActionDescriptor();
			desc.putReference(app.charIDToTypeID("null"), ref );
			desc.putBoolean(app.charIDToTypeID('MkVs'), false);
			executeAction(app.charIDToTypeID("slct"), desc, DialogModes.NO );

			var visible;
			
			var l = app.activeDocument.activeLayer;
		//	if( l.typename == "LayerSet")
		//		visible = l.visible;
		//	else
				visible = executeActionGet(ref).getBoolean(app.charIDToTypeID("Vsbl"));
				
			if( allLayers[l] >= 0 && layerStack[allLayers[l]] == l)
			{
				layerStack.splice( allLayers[l], 1);
				xmlDescriptions.splice( allLayers[l], 1);
				layersVisible.splice( allLayers[l], 1);
				allLayerBounds.splice( allLayers[l], 1);
			}
			allLayers[l] = layerStack.length;
			
			layerStack.push( l);
			
			if( layerStack.length == 60)
			{
				var a = 3;
			}
			
			if( l.typename == "LayerSet")
			{
				xmlDescriptions.push( "");
				layersVisible.push( visible);
				allLayerBounds.push(null);
				if( visible == false)
					$.removeLastLayerSet( layerStack, xmlDescriptions, layersVisible, allLayerBounds);
			} else
			{
				var r = l.bounds;
				var x1 = r[0]; x1.convert( "px");
				var y1 = r[1]; y1.convert( "px");
				var x2 = r[2]; x2.convert( "px");
				var y2 = r[3]; y2.convert( "px");
				if( Math.max(0,x1.value) == x2.value || Math.max(0,y1.value) == y2.value || x2 < 0 || y2 < 0 || x1 > dw || y1 > dh)
					visible = false;

				var b = new Object();
				b.x1 = x1.value;
				b.y1 = y1.value;
				b.x2 = x2.value;
				b.y2 = y2.value;
				allLayerBounds.push( b);

				var desc = $.getActiveLayerInfoByDocIndex(docIndex);
				xmlDescriptions.push( $.dumpDesc( desc, 0));
				layersVisible.push( visible);
			}
		}
	} catch( e)
	{
	}
	
	descXml = "<document width=\""+dw+"\" height=\""+dh+"\" resolution=\""+docoriginal.resolution+"\">\n";
	
	if( layerStack.length != layersVisible.length)
		throw new Error( "layerStack.length != layersVisible.length");
	if( layerStack.length != allLayerBounds.length)
		throw new Error( "layerStack.length != allLayerBounds.length");

	for( i = 0; i < layerStack.length; i++)
		if( layerStack[i] != $.emptyLayerSet && layerStack[i].typename != "LayerSet" && layersVisible[i] == true)
		{
			layerslist.push( layerStack[i]);
			xmlDescriptionsVisible.push( xmlDescriptions[i]);
			layerBounds.push( allLayerBounds[i]);
		}

/*	if( layerslist.length > 10)
	{
		alert( "This version is limited to 10 layers");
		return "";
	}*/

	var indices = new Array(), others = new Array();

	for( i = 0; i < layerslist.length; i++)
	{
		var r = layerBounds[i];
		
		var istext = false;
		try {
			istext = layerslist[i].kind == LayerKind.TEXT
		} catch(e)
		{
		}
		
		if( istext)
			break;
			
		if( r.x1 > 0 && r.y1 > 0 && r.x2 < dw && r.y2 < dh)
		{
			var doescover = false;
			// break if covers something not grouped
			for( var j = 0; j < others.length; j++)
				if( $.inters( layerBounds, i, others[j]))
				{
					doescover = true;
					break;
				}
			if( doescover)
				break;
			others.push( i);
			continue;
		}
		indices.push( i);
	}

	var layerIndex = new Object();

	if( indices.length > 0)
	{
		$.combineLayers( layerslist, xmlDescriptionsVisible, layerBounds, indices, "Background ", dw, dh);	
		layerIndex[0] = layerslist[0];
	}
	
	var groupedIndices = new Object();
	for( i = 1; i < layerslist.length; i++)
		if( layerslist[i] != null)
		{
			indices = new Array();
			indices.push( i);
			for( var j = i+1; j < layerslist.length; j++)
				if( layerslist[j] != null)
				{
					var intersany = false;
					for( var k = 1; k < j; k++)
						if( !groupedIndices[k] && $.inters( layerBounds, j, k))
						{
							intersany = true;
							break;
						}
					if( !intersany)
						indices.push( j);
				}
			if( indices.length > 1)
			{
				$.groupLayers( layerslist, indices, layerIndex);
				for( j = 0; j < indices.length; j++)
					groupedIndices[indices[j]] = true;
			}
		}
	
	for( i = 0; i < layerslist.length; i++)
		if( layerslist[i] != null)
			if( layerslist[i].length)
				;
			else
				layerIndex[i] = layerslist[i];

	for( i = 0; i < xmlDescriptionsVisible.length; i++)
	{
		var layer = layerIndex[i];
		if( !layer)
			throw new Error( "Wrong layerIndex!");
		
		var extra = "";
		var istext = false;
		try {
			istext = layer.kind == LayerKind.TEXT
		} catch(e)
		{
		}
		if( istext)
		{
			var ti = layer.textItem;
			var x = ti.position[0];
			x.convert("px");
			var y = ti.position[1];
			y.convert("px");
			extra = "x1=\""+x+"\" y1=\""+y+"\" ";
			
			var ispara = false;
			try {
				if( layer.textItem.kind == TextType.PARAGRAPHTEXT)
					ispara = true;
			} catch(e)
			{
			}
			
			if( ispara)
			{
				var width = ti.width;
				width.convert( "px");
				var height = ti.height;
				height.convert( "px");
				extra = extra + "width=\""+width+"\" height=\""+height+"\" ";
			}
		}
		extra += "kind=\""+layer.kind + "\" ";

		if( layer.length)
			extra = "kind=\"LayerKind.NORMAL\" ";
			
		for( j = 0; j < layerslist.length; j++)
			if( layerslist[j] != null && layerslist[j].length)
			{
				if( layerslist[j] == layer)
					break;
				var found = false;
				for( k = 0; k < layerslist[j].length; k++)
					if( layerslist[j][k] == layer)
					{
						found = true;
						break;
					}
				if( found)
					break;
			} else
				if( layerslist[j] == layer)
					break;
					
		if( j == layerslist.length)
			throw new Error( "Couldn't find layer!");
		
		var fileNameBody = exportInfo.fileNamePrefix + j;
		descXml += "<photoshoplayer file=\""+fileNameBody+".png\" "+extra+">\n" + xmlDescriptionsVisible[i] + "</photoshoplayer>\n";
	}

	descXml = descXml + "</document>\n";
		
    return descXml;
}

$.combineLayers = function( layerslist, xmlDescriptions, layerBounds, indices, id, dw, dh)
{
	var newlayers = new Array();
	for( var i = 0; i < indices.length; i++)
		newlayers.push( layerslist[indices[i]]);

	var desc = "<name>"+id+"</name><bounds>";
	desc += "<top><type>pixelsUnit</type><value>"+0+"</value></top>";
	desc += "<left><type>pixelsUnit</type><value>"+0+"</value></left>";
	desc += "<bottom><type>pixelsUnit</type><value>"+(dh+"").replace( " px", "")+"</value></bottom>";
	desc += "<right><type>pixelsUnit</type><value>"+(dw+"").replace( " px", "")+"</value></right>";
	desc += "</bounds>";
		
	for( var i = indices.length-1; i >= 0; i--)
	{
		layerslist.splice( indices[i], 1);
		xmlDescriptions.splice( indices[i], 1);
		layerBounds.splice( indices[i], 1);
	}
	layerslist.splice( indices[0], 0, newlayers);
	xmlDescriptions.splice( indices[0], 0, desc);
	layerBounds.splice( indices[0], 0, null);
}

$.groupLayers = function( layerslist, indices, layerIndex)
{
	var newlayers = new Array();
	for( var i = 0; i < indices.length; i++)
		newlayers.push( layerslist[indices[i]]);
		
	for( var i = indices.length-1; i >= 0; i--)
		layerslist[indices[i]] = null;
	layerslist.splice( indices[0], 1, newlayers);
	
	for( i = 0; i < indices.length; i++)
		layerIndex[indices[i]] = newlayers[i];
}

$.inters = function( layerBounds, a, b)
{
	var ra = layerBounds[a];
	var rb = layerBounds[b];
	
	return !(ra.x2 < rb.x1 || ra.y2 < rb.y1 || ra.x1 > rb.x2 || ra.y1 > rb.y2); // groups layers as low-z as we can
}

//BREAK

$.removeLastLayerSet = function ( layerslist, xmlDescriptions, layersVisible, allLayerBounds)
{
	var ls = layerslist.pop();
	xmlDescriptions.pop();
	layersVisible.pop();
	allLayerBounds.pop();
		
	var artlayersremove = ls.artLayers.length;
	var layersetsremove = ls.layerSets.length;
	
	// go back and remove 
	while( artlayersremove > 0 || layersetsremove > 0)
	{
		var l = layerslist[layerslist.length-1];
		if( l == $.emptyLayerSet || l.typename == "LayerSet")
		{
			if( l == $.emptyLayerSet || l.parent != ls)
			{
				layerslist.pop();
				xmlDescriptions.pop();
				layersVisible.pop();
				allLayerBounds.pop();
				if( l == $.emptyLayerSet)
					layersetsremove--;
			} else
			{
				$.removeLastLayerSet( layerslist, xmlDescriptions, layersVisible, allLayerBounds);
				layersetsremove--;
			}
		} else
		{
			layerslist.pop();
			xmlDescriptions.pop();
			layersVisible.pop();
			allLayerBounds.pop();
			if( l.parent == ls)
				artlayersremove--;
		}
	}

	// push a virtual reference to ls
	layerslist.push( $.emptyLayerSet);
	xmlDescriptions.push( "");
	layersVisible.push( false);
	allLayerBounds.push(null);
}

//BREAK

$.showHideLayer = function( layer, show)
{
	if( layer.length)
	{
		for( var i = 0; i < layer.length; i++)
			$.showHideLayer( layer[i], show);
	}
	try {
		layer.visible = show;
	} catch(e)
	{
	}
}

$.exportSingleImages = function (layerslist, exportInfo) {
	for( var i = 0; i < layerslist.length; i++)  
		if( layerslist[i] != null)
		{
			var fileNameBody = exportInfo.fileNamePrefix + i;

			var l = layerslist[i];

			$.showHideLayer( layerslist[i], true);
			$.showHideRelatedLayers( layerslist, i, true);
			
			var histindex = 0;

			for( histindex = app.activeDocument.historyStates.length-1; histindex >= 0; histindex--)
				if( app.activeDocument.activeHistoryState == app.activeDocument.historyStates[histindex])
					break;

			if( layerslist[i].length)
				for( var j = 0; j < layerslist[i].length; j++)
					$.hideLayerEffects( layerslist[i][j]);
			else
				$.hideLayerEffects( layerslist[i]);

			$.saveFile(app.activeDocument, fileNameBody+"_single", exportInfo);
			
			app.activeDocument.activeHistoryState = app.activeDocument.historyStates[histindex];
				
			$.showHideLayer( layerslist[i], false);
			$.showHideRelatedLayers( layerslist, i, false);
		}
}

$.hideLayerEffects = function( l)
{
	var istext = false;
	try {
		istext = l.kind == LayerKind.TEXT;
	} catch(e)
	{
	}

	if( istext)
	{
		app.activeDocument.activeLayer = l;
		//var font = l.textItem.font;
		// hide effects
		var id10 = charIDToTypeID( "Hd  " );
		var desc4 = new ActionDescriptor();
		var id11 = charIDToTypeID( "null" );
			var list1 = new ActionList();
				var ref2 = new ActionReference();
				var id12 = charIDToTypeID( "Lefx" );
				ref2.putClass( id12 );
				var id13 = charIDToTypeID( "Lyr " );
				var id14 = charIDToTypeID( "Ordn" );
				var id15 = charIDToTypeID( "Trgt" );
				ref2.putEnumerated( id13, id14, id15 );
			list1.putReference( ref2 );
		desc4.putList( id11, list1 );
		try {
			executeAction( id10, desc4, DialogModes.NO );
		} catch(e)
		{
		}
	}
}

//BREAK

$.exportCompositeImages = function (layerslist, exportInfo) {
	for( var i = 0; i < layerslist.length; i++)  
		if( layerslist[i] != null)
		{
			var fileNameBody = exportInfo.fileNamePrefix + i;

			$.showHideLayer( layerslist[i], true);
			$.showHideRelatedLayers( layerslist, i, true);
			
			$.saveFile(app.activeDocument, fileNameBody, exportInfo);
		}
}

//BREAK

$.isAdjustmentLayer = function( layer)
{
	return layer.kind == LayerKind.HUESATURATION
			|| layer.kind == LayerKind.LEVELS
			|| layer.kind == LayerKind.BRIGHTNESSCONTRAST
			|| layer.kind == LayerKind.CHANNELMIXER
			|| layer.kind == LayerKind.COLORBALANCE
			|| layer.kind == LayerKind.CURVES
			|| layer.kind == LayerKind.EXPOSURE
			|| layer.kind == LayerKind.INVERSION
			|| layer.kind == LayerKind.POSTERIZE
			|| layer.kind == LayerKind.THRESHOLD
			|| layer.kind == LayerKind.SELECTIVECOLOR
			|| layer.kind == LayerKind.GRADIENTMAP;
}

$.showHideRelatedLayers = function (layerslist, i, show) 
{
}

$.getDocumentIndex = function (doc) {
  var docs = app.documents;
  for (var i = 0; i < docs.length; i++) {
    if (doc == docs[i]) {
      return i+1;
    }
  }
  return undefined;
};

//BREAK

$.writeFile = function (msg, saveFile)
{
    try {
        saveFile.open("w"); // open as write
        saveFile.encoding = "UTF8";
        saveFile.write(msg);
        saveFile.close();
//        alert(saveFile.fsName + " has been written.");
    } catch (e) {
        alert(e);
    } finally {
    }
    return;
}

$.settingDialog = function (exportInfo) {
    // get setting from dialog
    exportInfo.destination = $.basepath+"/" + $.docName;
    exportInfo.fileNamePrefix = $.docName;
    return true;
}

$.initExportInfo = function (exportInfo) {
    exportInfo.psdMaxComp = true;
}

//BREAK

$.saveFile = function ( docRef, fileNameBody, exportInfo) {
    var saveFile = new File(exportInfo.destination + "/" + fileNameBody + ".png");
    pngSaveOptions = new PNGSaveOptions();
    pngSaveOptions.interlaced = false;
	//pngSaveOptions.depth = BMPDepthType.THIRTYTWO;
    docRef.saveAs(saveFile, pngSaveOptions, true, Extension.LOWERCASE);	
}

$.SetInvisibleAllArtLayers = function (layerlist) {
    for( var i = 0; i < layerlist.length; i++) 
		if( layerlist[i] != null)
		{
			if( layerlist[i].typename != "LayerSet")
				$.showHideLayer( layerlist[i], false);
		}
}

$.BoundsIntersect = function ( r1, r2)
{
	if( r1[0] > r2[2])
		return false;
	if( r1[1] > r2[3])
		return false;
	if( r2[0] > r1[2])
		return false;
	if( r2[1] > r1[3])
		return false;
	return true;
}

//BREAK

$.getDescriptorElement = function (desc, key) {
  if (desc.hasKey && !desc.hasKey(key)) {
    return undefined
  }
  var typeID = desc.getType(key);
  var v;
  switch (typeID) {
    case DescValueType.ALIASTYPE:   v = desc.getPath(key); break;
    case DescValueType.BOOLEANTYPE: v = desc.getBoolean(key); break;
    case DescValueType.CLASSTYPE:   v = desc.getClass(key); break;
    case DescValueType.DOUBLETYPE:  v = desc.getDouble(key); break;
    case DescValueType.ENUMERATEDTYPE:
      v = "<type>"+app.typeIDToStringID(desc.getEnumerationType(key))+"</type><value>"+app.typeIDToStringID(desc.getEnumerationValue(key))+"</value>";
      break;
    case DescValueType.INTEGERTYPE: v = desc.getInteger(key); break;
    case DescValueType.LISTTYPE:    v = desc.getList(key); break;
    case DescValueType.OBJECTTYPE:
      v = desc.getObjectValue(key);
      break;
    case DescValueType.RAWTYPE:       v = desc.getData(key); break;
    case DescValueType.REFERENCETYPE: v = desc.getReference(key); break;
    case DescValueType.STRINGTYPE:    v = $.convertText( desc.getString(key)); break;
    case DescValueType.UNITDOUBLE:
	  v = "<type>"+app.typeIDToStringID(desc.getUnitDoubleType(key))+"</type><value>"+desc.getUnitDoubleValue(key)+"</value>";
      break;
  }

  return v;
};

//BREAK

$.getReferenceElement = function (desc) {
  var typeID = desc.getForm();
  var v;
  switch (typeID) {
    case ReferenceFormType.CLASSTYPE:   
		v = "<class>"+app.typeIDToStringID(desc.getDesiredClass())+"</class>"; 
		break;
    case ReferenceFormType.ENUMERATED: 
		v = "<type>"+app.typeIDToStringID(desc.getEnumeratedType())+"</type><value>"+app.typeIDToStringID(desc.getEnumeratedValue())+"</value>";
		break;
    case ReferenceFormType.IDENTIFIER:   
		v = "<identifier>"+app.typeIDToStringID(desc.getIdentifier())+"</identifier>"; 
		break;
    case ReferenceFormType.INDEX:   
		v = "<index>"+(desc.getIndex())+"</index>"; 
		break;
    case ReferenceFormType.NAME:   
		v = "<name>"+(desc.getName())+"</name>"; 
		break;
    case ReferenceFormType.OFFSET:   
		v = "<offset>"+(desc.getOffset())+"</offset>"; 
		break;
    case ReferenceFormType.PROPERTY:   
		v = "<property>"+(desc.getProperty())+"</property>"; 
		break;
  }

  return v;
};

//BREAK

$.getActiveLayerInfoByDocIndex = function (parentIndex) 
{
  var ref = new ActionReference();
  var id6 = charIDToTypeID( "Lyr " );
  var id7 = charIDToTypeID( "Ordn" );
  var id8 = charIDToTypeID( "Trgt" );
  ref.putEnumerated( id6, id7, id8 );
  ref.putIndex(app.charIDToTypeID("Dcmn"), parentIndex);

  var desc = app.executeActionGet(ref);

  // XXX potential problems with objects, units, and enums
  return desc;
};

$.convertText = function ( s)
{
	s = s.replace(/&/g, "&amp;");
	s = s.replace(/</g, "&lt;");
	s = s.replace(/>/g, "&gt;");
	return s;
}

//BREAK

$.dumpDesc = function ( desc, level)
{
	if( desc.typename == "ActionReference")
	{
		var xml = "" + $.getReferenceElement( desc);
		return xml;
	} else
	if( desc.typename == "ActionList")
	{
		var xml = "";
		var i = 0;
		for( i = 0; i < desc.count; i++)
		{
			xml += "<item>\n";
			var value = $.getDescriptorElement( desc, i);
			if( (value+"").substring(0,1) == "[")
				xml += $.dumpDesc( value, level+1);
			else
				xml += value+"";
			xml += "</item>\n";
		}
		return xml;
	} else
	if( desc.typename == "ActionDescriptor")
	{
		var xml = "";
		var i = 0;
		for( i = 0; i < desc.count; i++)
		{
			var key = desc.getKey(i);
			var tag = app.typeIDToStringID( key);
			var value = $.getDescriptorElement(desc, key);
			
			if( tag == "textStyleRange")
				var j = 3;
			
			if( (value+"") == "[ActionReference]" || (value+"") == "[ActionList]" || (value+"") == "[ActionDescriptor]")
				xml += "<"+tag+">"+$.dumpDesc(value, level+1)+"</"+tag+">\n";
			else {
				if( (value+"").indexOf( "\0") >= 0)
					value = "";
				xml += "<"+tag+">"+value+"</"+tag+">\n";
			}
		}
		return xml;
	} else
		alert( "Unknown typename " + desc.typename);
}

$.FlexProcessing = function( resultPath)
{
	var todoFile = new File(app.path.fsName + "/Presets/Scripts/psdbreaker.todo.txt");
	todoFile.open("w");
	todoFile.writeln( resultPath);
	todoFile.close();
	
	var os = $.os.substr(0,3).toLowerCase();
	if( os == "win")
	{
		var f = new File( $.GetAirPath()+"/PSDBreaker.exe");
		f.execute();
	} else 
	if( os == "mac")
	{
		var f = new File( $.GetAirPath()+"/PSDBreaker.app");
		f.execute();
	}
}

$.GetAirPath = function()
{
	// get PSDBreaker path
	var iniFile = new File(app.path.fsName + "/Presets/Scripts/psdbreaker.ini");
	iniFile.open( "r");
	var path = iniFile.readln();
	iniFile.close();
	var os = $.os.substr(0,3).toLowerCase();
	if( os == "mac")
	{
		path = path.replace( "/PSDBreaker.app/Contents/Resources", "");
	}
	return path;
}

function main()
{
	var resultPath = $.convertActiveDocument("",false);
	if( resultPath != "")
		$.FlexProcessing( resultPath);
}

main();



